#ifndef __WIDGET_H
#define __WIDGET_H

struct widget_s {
unsigned short rel_x; /* ⭮⥫쭮  */
unsigned short rel_y; /* ⭮⥫쭮  */
unsigned short w;
unsigned short h;
void (*do_layout)(struct widget_s *this);
void (*do_redraw)(struct widget_s *this);
struct widget_s *child;
struct widget_s *next;
void *widget_date;
};

struct short_rect {
	unsigned short x;
	unsigned short y;
	unsigned short w;
	unsigned short h;
};

#include "global.h"

void do_child_layout(struct widget_s *child, struct short_rect *cur);
void do_child_redraw(struct widget_s *child);

void default_do_layout(struct widget_s *this);
void default_do_redraw(struct widget_s *this);
void default_widget_constructor(struct widget_s *this);

#endif
