#include "button.h"

/*
void kol_btn_define(unsigned x, unsigned y, unsigned w, unsigned h, 
						unsigned d, unsigned c)
{
asm ("nop"::"b"(x*65536+w), "c"(y*65536+h), "d"(d));
asm ("nop"::"a"(c));
asm ("movl %eax, %esi");
asm ("int $0x40"::"a"(8));
}
*/



void button_do_layout(struct widget_s *this)
{
	struct button_date *ld = (struct button_date *) this->widget_date;

	struct short_rect cur= {
		this->rel_x + 2 , this->rel_y + 2 + ld->h, 
		ld->w, ld->h
		};
	
	do_child_layout(this->child, &cur);

	cur.w +=2;	cur.h +=2;
	this->w = cur.w; this->h = cur.h;
	return;
}


void button_do_redraw(struct widget_s *this)
{
	struct button_date *ld = (struct button_date *) this->widget_date;

	kol_paint_bar(this->rel_x , this->rel_y , this->w , this->h , 
					global_colours.work);
	kos_paint_rectangle	(this->rel_x , this->rel_y , this->w , this->h ,
					global_colours.frames);
	
	/*
	kol_btn_define(this->rel_x + 1 , this->rel_y + 1 , 
				   ld->w - 2 , ld->h - 2 ,
				   ld->id, global_colours.work_button);
	*/
	
	kos_btndef( __XY( (this->rel_x + 1) , (ld->w - 2)),
				__XY((this->rel_y + 1 ),(ld->h - 2)),
				ld->id, global_colours.work_button);
	kol_paint_string(this->rel_x + 5 , this->rel_y + 5, 
				ld->text, global_colours.work_button_text + 0x80000000);
	
	
	do_child_redraw(this->child);

	return;
}


void button_widget_constructor(struct widget_s *this,
							  struct button_date *ld)
{
	this->rel_x = this->rel_y = 2;
	this->w = ld->w; this->h = ld->h;
	this->do_layout = &button_do_layout;
	this->do_redraw = &button_do_redraw;
	this->child = this->next = NULL;
	this->widget_date = (void *)ld;
}
