#include "ewidget.h"

void ewidget_do_layout(struct widget_s *this)
{
	struct ewidget_date *d = (struct ewidget_date *) this->widget_date;
	struct short_rect cur = {
		this->rel_x, this->rel_y + d->h, d->w, d->h
		};

	do_child_layout(this->child, &cur);

	this->w = cur.w; this->h = cur.h;
	return;
}

void ewidget_do_redraw(struct widget_s *this)
{
	do_child_redraw(this->child);
	
	return;
}

void ewidget_widget_constructor(struct widget_s *this, 
								struct ewidget_date *d)
{
	this->rel_x = this->rel_y = 0;
	this->w = d->w ; this->h = d->h;
	this->do_layout = &ewidget_do_layout;
	this->do_redraw = &ewidget_do_redraw;
	this->child = this->next = NULL;
	this->widget_date = (void *) d;
}
