#include "t3bel.h"

void t3bel_do_layout(struct widget_s *this)
{
	struct t3bel_date *ld = (struct t3bel_date *) this->widget_date;

	struct short_rect cur= {
		this->rel_x  , this->rel_y + (ld->el_h)*3, 
		ld->t_w + ld->i_w + ld->b_w, (ld->el_h)* 3
		};
	
	do_child_layout(this->child, &cur);

	//cur.w +=2;	cur.h +=2;
	this->w = cur.w; this->h = cur.h;
	return;
}

void t3bel_do_refresh(struct widget_s *this)
{
	struct t3bel_date *ld = (struct t3bel_date *) this->widget_date;
	struct cpu_count_holder *d = ld->date;
	unsigned short cx = this->rel_x;
	unsigned short cy = this->rel_y;
	kol_paint_bar(cx, cy , this->w , this->h , 
					global_colours.work);
	kos_paint_rectangle	(cx , cy , this->w , this->h ,
					global_colours.frames);
	
	/* ⢥ ७  */
	cx += 5; cy += 5;
	kol_paint_string(cx , cy, 
					ld->text1, global_colours.work_text + 0x80000000);
	cy+=ld->el_h;
	kol_paint_string(cx , cy, 
					ld->text2, global_colours.work_text + 0x80000000);
	cy+=ld->el_h;
	kol_paint_string(cx , cy, 
					ld->text3, global_colours.work_text + 0x80000000);
	
	cx = this->rel_x + ld->t_w; cy = this->rel_y + 5;
	kos_sh_llong_d(&(d->start), __XY(cx,cy) , global_colours.work_text);
	cy+=ld->el_h;
	kos_sh_llong_d(&(d->stop), __XY(cx,cy) , global_colours.work_text);
	cy+=ld->el_h;
	kos_sh_llong_d(&(d->delta), __XY(cx,cy) , global_colours.work_text);
	
	cx += ld->i_w; cy = this->rel_y + ld->el_h;
	kos_btndef( __XY( cx , (ld->b_w - 1) ), /* Correction */
				__XY( cy , ld->el_h),
				ld->button_id, global_colours.work_button);
	cx += 5; cy += 5;
	kol_paint_string(cx, cy, ld->b_text,
				 global_colours.work_button_text + 0x80000000);
	
	/* --- END --- */
}

void t3bel_do_redraw(struct widget_s *this)
{
	t3bel_do_refresh(this);
	
	do_child_redraw(this->child);

	return;
}

void t3bel_widget_constructor(struct widget_s *this,
							  struct t3bel_date *ld,
							  struct cpu_count_holder *d)
{
	this->rel_x = this->rel_y = 2;
	this->w = ld->t_w + ld->i_w + ld->b_w; this->h = 3*ld->el_h;
	this->do_layout = &t3bel_do_layout;
	this->do_redraw = &t3bel_do_redraw;
	this->child = this->next = NULL;
	this->widget_date = (void *)ld;
	ld->date = d;
}

