#ifndef __SYSFN9ALT_H
#define __SYSFN9ALT_H

/**
 * ⪨ ୠ⨢ ⥬ 맮
 * */

/* 0 */
struct main_proc_info_s 
{
	unsigned int proc_addr;
	unsigned int mem_usage;
	unsigned int pid;
	char name[11];
	char res_2;
}__attribute__((packed));

int kos_main_proc_info(int slot, struct main_proc_info_s *pinfo);


/* 1 */
struct main_thread_info_s
{
	unsigned int thread_state;
	unsigned int tid;
	unsigned int ev_mask;
	unsigned int cpu_usage; 
}__attribute__((packed));

int kos_main_tread_info(int slot, struct main_thread_info_s *tinfo);


/* 2 */
struct main_win_info_s
{
	unsigned int x;
	unsigned int y;
	unsigned int w;
	unsigned int h;
}__attribute__((packed));

int kos_main_win_info(int slot, struct main_win_info_s *winfo);


/* 3 */
struct main_win_cai_s
{
	unsigned int client_x;
	unsigned int client_y;
	unsigned int client_w;
	unsigned int client_h;
}__attribute__((packed));

int kos_main_win_cai(int slot, struct main_win_cai_s *wcai);


/* 4 */
struct adv_win_s
{
	unsigned int winstack;
	unsigned int win_state;
	unsigned int ecx_pos_slot;
	unsigned int max_slot; /* In SysFn9 - return value in eax */
}__attribute__((packed));

int kos_adv_win_i(int slot, struct adv_win_s *advi);

#endif
