#include "uint_label.h"

extern void kos_uint_paint_d(unsigned int i, unsigned int x_y, unsigned int c);
extern void kos_uint_paint_h(unsigned int i, unsigned int x_y, unsigned int c);
extern void kos_uint_paint_b(unsigned int i, unsigned int x_y, unsigned int c);


void uint_do_layout(struct widget_s *this)
{
	struct uint_date *ld = (struct uint_date *) this->widget_date;

	struct short_rect cur= {
		this->rel_x, this->rel_y + ld->h, 
		ld->w, ld->h
		};
	
	do_child_layout(this->child, &cur);

	this->w = cur.w; this->h = cur.h;
	return;	
}

void uint_do_redraw(struct widget_s *this)
{
	struct uint_date *ld = (struct uint_date *) this->widget_date;

	kol_paint_bar(this->rel_x , this->rel_y , this->w , this->h , 
					global_colours.work);
	
	unsigned int where_paint = __XY( (this->rel_x +2 ) , (this->rel_y + 2) ); 
	
	switch (ld->type)
	{
		case 0:
			kos_uint_paint_d(ld->num ,where_paint , ld->colour );
			break;
		case 1:
			kos_uint_paint_h(ld->num ,where_paint , ld->colour );
			break;
		case 2:
			break;
			kos_uint_paint_b(ld->num ,where_paint , ld->colour );
	}
	
	do_child_redraw(this->child);

	return;	
}

void uint_widget_constructor(struct widget_s *this,
							 struct uint_date *ld)
{
	this->rel_x = this->rel_y = 2;
	this->w = ld->w; this->h = ld->h;
	this->do_layout = &uint_do_layout;
	this->do_redraw = &uint_do_redraw;
	this->child = this->next = NULL;
	this->widget_date = (void *)ld;
}
