#ifndef __GLOBAL_H
#define __GLOBAL_H

#define NULL ((void*)0)

#define __XY(A, B) (A*0x10000 + B)

struct procinfo_s {
	unsigned int cpu_usage;
	unsigned short winstack;
	unsigned short ecx_pos_slot;
	unsigned short res_1;
	char name[11];
	char res_2;
	unsigned int proc_addr;
	unsigned int mem_usage;
	unsigned int pid;
	unsigned int x;
	unsigned int y;
	unsigned int w;
	unsigned int h;
	unsigned short proc_state;
	unsigned short res_3;
	unsigned int client_x;
	unsigned int client_y;
	unsigned int client_w;
	unsigned int client_h;
	unsigned char win_state;
	unsigned int event_mask;
	char zero[20];
}__attribute__((packed));

struct kos_syscolours {
	unsigned int frames; // - 梥 ࠬ 
	unsigned int grab; // - 梥  
	unsigned int grab_button; // - 梥     
	unsigned int grab_button_text; // - 梥 ⥪      
	unsigned int grab_text; // - 梥 ⥪   
	unsigned int work; // - 梥 ࠡ祩  
	unsigned int work_button; // - 梥   ࠡ祩  
	unsigned int work_button_text; // - 梥 ⥪    ࠡ祩  
	unsigned int work_text; // - 梥 ⥪  ࠡ祩  
	unsigned int work_graph; // - 梥 䨪  ࠡ祩  
}__attribute__((packed));

union procinfo_u {
	char place[128];
	struct procinfo_s info;
};

#ifdef __GLOBAL_HOLDER

union procinfo_u global_procinfo;
struct kos_syscolours global_colours;

#else 

extern struct procinfo_s global_procinfo;
extern struct kos_syscolours global_colours;

#endif

/*  ⨯ ⠭ 㭪権 */
unsigned kol_process_info(unsigned slot, struct procinfo_s *buf);

void kol_paint_start();

void kol_paint_end();

/* */
unsigned kol_event_wait();

unsigned kol_key_get();

unsigned kol_btn_get();


/* ⨯ ᮡ⢥ 㭪権 */

void kos_get_syscolours(struct kos_syscolours *buf);

#endif
