#include "label.h"

void kol_paint_string(unsigned x, unsigned y, char *s, unsigned c)
{
asm ("int $0x40"::"a"(4), "b"(x*65536+y), "c"(c), "d"(s));
}

void label_do_layout(struct widget_s *this)
{
	struct label_date *ld = (struct label_date *) this->widget_date;

	struct short_rect cur= {
		this->rel_x, this->rel_y + ld->h, 
		ld->w, ld->h
		};
	
	do_child_layout(this->child, &cur);

	//cur.w +=2;	cur.h +=2;
	this->w = cur.w; this->h = cur.h;
	return;	
}

void label_do_redraw(struct widget_s *this)
{
	struct label_date *ld = (struct label_date *) this->widget_date;

	kol_paint_bar(this->rel_x , this->rel_y , this->w , this->h , 
					global_colours.work);
	kos_paint_rectangle	(this->rel_x , this->rel_y , this->w , this->h ,
					global_colours.frames);
	
	kol_paint_string(this->rel_x + 5 , this->rel_y + 5, 
					ld->text, global_colours.work_text + 0x80000000);
	kos_paint_rectangle(this->rel_x + 2 , this->rel_y + 2, 
					ld->w - 4 , ld->h - 4 ,
					global_colours.frames);
	
	do_child_redraw(this->child);

	return;	
}

void label_widget_constructor(struct widget_s *this,
							  struct label_date *ld)
{
	this->rel_x = this->rel_y = 2;
	this->w = ld->w; this->h = ld->h;
	this->do_layout = &label_do_layout;
	this->do_redraw = &label_do_redraw;
	this->child = this->next = NULL;
	this->widget_date = (void *)ld;
}
