#include "widget.h"

/* ⠭ 㭪 */

void kol_paint_line(unsigned x1, unsigned y1, unsigned x2, unsigned y2, unsigned c)
{
asm ("int $0x40"::"a"(38), "b"(x1*65536+x2), "c"(y1*65536+y2), "d"(c));
}


/* ⢥ 㭪樨 */

void kos_paint_rectangle(unsigned x , unsigned y , unsigned w , unsigned h, unsigned c)
{
	kol_paint_line(x , y , x + w , y, c);
	kol_paint_line(x , y , x , y + h, c);
	kol_paint_line(x+w , y , x+w , y+h, c);
	kol_paint_line(x , y+h , x+w , y+h, c);
	return;
}

void kol_paint_bar(unsigned x, unsigned y, unsigned w, unsigned h, unsigned c)
{
asm ("int $0x40"::"a"(13), "b"(x*65536+w), "c"(y*65536+h), "d"(c));
} 


void do_child_layout(struct widget_s *child, struct short_rect *cur)
{
	while (child != NULL) 
	{
		child->rel_x = cur->x + 2;
		child->rel_y = cur->y + 2;
		child->do_layout(child);
		if (cur->w < (child->w + 4)) cur->w = (child->w + 4);
		cur->y += (child->h + 4) ; cur->h += (child->h + 4);
		child = child->next;
	} /* while */
}

void default_do_layout(struct widget_s *this)
{
	struct short_rect cur = {
		this->rel_x + 5, this->rel_y + 5, 0 , 0
		};

	do_child_layout(this->child, &cur);

	cur.w +=10;	cur.h +=10;
	this->w = cur.w; this->h = cur.h;
	return;
}

void do_child_redraw(struct widget_s *child)
{
	while (child != NULL) 
	{
		child->do_redraw(child);
		child = child->next;
	} /* while */
}

void default_do_redraw(struct widget_s *this)
{
	kol_paint_bar(this->rel_x , this->rel_y , this->w , this->h , 0x00ff0000);
	kos_paint_rectangle	(this->rel_x , this->rel_y , this->w , this->h , 0x00ffffff);
	
	do_child_redraw(this->child);
	
	return;
}

void default_widget_constructor(struct widget_s *this)
{
	this->rel_x = this->rel_y = this->w = this->h = 0;
	this->do_layout = &default_do_layout;
	this->do_redraw = &default_do_redraw;
	this->child = this->next = NULL;
	this->widget_date = NULL;
};
